﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System;
using AcknexWrapper.Native;
using System.Runtime.InteropServices;

namespace AcknexWrapper
{
    public class Color : Vector
    {
        public Var blue
        {
            get
            {
                return X;
            }
            set
            {
                this.X = value;
            }
        }

        public Var green
        {
            get
            {
                return Y;
            }
            set
            {
                this.Y = value;
            }
        }

        public Var red
        {
            get
            {
                return Z;
            }
            set
            {
                this.Z = value;
            }
        }

        /// <summary>
        /// standard constructor
        /// </summary>
        public Color(Var blue, Var green, Var red)
            : base(blue, green, red)
        {
        }

        public static explicit operator Color(IntPtr d)
        {
            Color tempColor = new Color((Var)0, (Var)0, (Var)0);
            unsafe
            {
                tempColor.x = (Var)(IntPtr)(&(*((NativeVector*)d)).x);
                tempColor.y = (Var)(IntPtr)(&(*((NativeVector*)d)).y);
                tempColor.z = (Var)(IntPtr)(&(*((NativeVector*)d)).z);
            }
            tempColor.setPointer(d);
            return tempColor;
        }

        public static explicit operator IntPtr(Color d)   //return a pointer to the structure stored in unmanaged memory
        {
            if (d.getPointer() == IntPtr.Zero)
            {
                d.setPointer(Marshal.AllocHGlobal(Marshal.SizeOf(typeof(NativeVector))));
                d.HiddenVector.x = (NativeVar)d.x;
                d.HiddenVector.y = (NativeVar)d.x;
                d.HiddenVector.z = (NativeVar)d.x;
                Marshal.StructureToPtr(d.HiddenVector, d.getPointer(), false);
            }
            return d.getPointer();
        }
    }
}