﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System;
using System.Runtime.InteropServices;
using AcknexWrapper.Native;

namespace AcknexWrapper
{

    public class FONT
    {
        private unsafe NativeFONT* FONTPointer;

        /// <summary>
        /// constructor that initializes the object
        /// </summary>
        public FONT(IntPtr param0)
        {
            unsafe
            {
                FONTPointer = (NativeFONT*)param0;
            }
        }

        /* -------- a7.FONT -------- */
        /* a7.FONT to a7.NativeFONT* (address in void*) */
        public static explicit operator IntPtr(FONT d)
        {
            unsafe
            {
                if (d == null)
                {
                    return IntPtr.Zero;
                }
                else
                {
                    return (IntPtr)(NativeFONT*)d.FONTPointer;
                }
            }
        }
        /* a7.NativeFONT* (address in void*) to a7.FONT */
        public static explicit operator FONT(IntPtr d)
        {
            unsafe
            {
                if (d == IntPtr.Zero)
                {
                    return null;
                }
                return new FONT(d);
            }
        }

        public int dy
        {
            get
            {
                unsafe
                {
                    return (*FONTPointer).dy;
                }
            }
        }

    }
}