﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System.Runtime.InteropServices;

namespace AcknexWrapper
{
    namespace Native
    {
        [StructLayout(LayoutKind.Sequential)]
        internal struct NativeVar
        {
            public int mValue;

            /// <summary>
            /// casts a Var to a NativeVar
            /// </summary>
            public static explicit operator NativeVar(Var d)
            {
                NativeVar tempVar = new NativeVar();
                tempVar.mValue = d.getRealInt();
                return tempVar;
            }
            /// <summary>
            /// casts a NativeVar to a Var
            /// </summary>
            public static explicit operator Var(NativeVar d)
            {
                Var tempVar = new Var();
                tempVar.setRealInt(d.mValue);
                return tempVar;
            }
        }
    }
}