﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System.Runtime.InteropServices;

namespace AcknexWrapper
{
    namespace Native
    {
        [StructLayout(LayoutKind.Sequential)]
        internal struct NativeVector
        {
            public NativeVar x;
            public NativeVar y;
            public NativeVar z;

            /* -------- a7.VECTOR -------- */
            /* VECTOR to hidden.VECTOR */
            public static explicit operator NativeVector(Vector d)
            {
                NativeVector tempVector = new NativeVector();
                tempVector.x = (NativeVar)d.x;
                tempVector.y = (NativeVar)d.y;
                tempVector.z = (NativeVar)d.z;
                return tempVector;
            }
            /* hidden.VECTOR to VECTOR */
            public static explicit operator Vector(NativeVector d)
            {
                return new Vector(
                    (Var)d.x,
                    (Var)d.y,
                    (Var)d.z
                );
            }
        }
    }
}