﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System;
using System.Runtime.InteropServices;
using AcknexWrapper.Native;

namespace AcknexWrapper
{
    public class SOUND
    {
        private unsafe NativeSOUND* SOUNDPointer;

        /// <summary>
        /// constructor that initializes the object
        /// </summary>
        public SOUND(IntPtr param0)
        {
            unsafe
            {
                SOUNDPointer = (NativeSOUND*)param0;
            }
        }

        /* -------- a7.SOUND -------- */
        /* a7.SOUND to a7.NativeSOUND* (address in void*) */
        public static explicit operator IntPtr(SOUND d)
        {
            unsafe
            {
                if (d == null)
                {
                    return IntPtr.Zero;
                }
                else
                {
                    return (IntPtr)(NativeSOUND*)d.SOUNDPointer;
                }
            }
        }
        /* a7.NativeSOUND* (address in void*) to a7.SOUND */
        public static explicit operator SOUND(IntPtr d)
        {
            unsafe
            {
                if (d == IntPtr.Zero)
                {
                    return null;
                }
                return new SOUND(d);
            }
        }
    }
}