﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System;
using System.Runtime.InteropServices;
using AcknexWrapper.Native;

namespace AcknexWrapper
{
    public class STRING
    {
        private unsafe NativeSTRING* STRINGPointer;

        /// <summary>
        /// constructor that initializes the object
        /// </summary>
        public STRING(IntPtr param0)
        {
            unsafe
            {
                STRINGPointer = (NativeSTRING*)param0;
            }
        }

        /* -------- String -------- */
        /* a7.STRING to String */
        public static implicit operator String(STRING d)
        {
            unsafe
            {
                return Marshal.PtrToStringAnsi((IntPtr)(*d.STRINGPointer).chars);
            }
        }
        /* String to a7.STRING */
        public static implicit operator STRING(String d)
        {
            unsafe
            {
                return (STRING)EngFun.str_create(d);
            }
        }

        /* -------- a7.STRING -------- */
        /* a7.STRING to a7.NativeSTRING* (address in void*) */
        public static explicit operator IntPtr(STRING d)
        {
            unsafe
            {
                if (d == null)
                {
                    return IntPtr.Zero;
                }
                else
                {
                    return (IntPtr)(NativeSTRING*)d.STRINGPointer;
                }
            }
        }
        /* a7.NativeSTRING* (address in void*) to a7.STRING */
        public static explicit operator STRING(IntPtr d)
        {
            unsafe
            {
                if (d == IntPtr.Zero)
                {
                    return null;
                }
                return new STRING(d);
            }
        }
    }
}