﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FXED.Forms
{
    public partial class frm_options : Form
    {
        public frm_options()
        {
            InitializeComponent();
        }

        private void frm_options_Load(object sender, EventArgs e)
        {
            // load settings
            
            chk_embed_model.Checked = Properties.Settings.Default.EmbedModel;
            chk_embed_sky.Checked = Properties.Settings.Default.EmbedSky;
            cmb_antialias.SelectedItem = Properties.Settings.Default.AntialiasLevel;
            nmr_lightres.Value = Properties.Settings.Default.LightResolutionLevel;
            nmr_anisotrophy.Value = Properties.Settings.Default.AnistrophicLevel;
            chk_replace_skins.Checked = Properties.Settings.Default.ReplaceSkins;
            chk_recompile.Checked = Properties.Settings.Default.AutoRecompile;

            btn_comment_color.BackColor = Properties.Settings.Default.CommentColor;
            btn_preprocessor_color.BackColor = Properties.Settings.Default.PreProcessorColor;
            btn_string_color.BackColor = Properties.Settings.Default.StringColor;
            btn_character_color.BackColor = Properties.Settings.Default.CharacterColor;
            btn_keyword_color.BackColor = Properties.Settings.Default.KeywordColor;
            btn_function_color.BackColor = Properties.Settings.Default.FunctionColor;
            btn_component_color.BackColor = Properties.Settings.Default.ComponentColor;
            btn_semantic_color.BackColor = Properties.Settings.Default.SemanticColor;
            btn_parameter_color.BackColor = Properties.Settings.Default.ParameterColor;

            dlr_fnt.Font = Properties.Settings.Default.EditorFont;
        }

        private void btn_ok_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.EmbedModel = chk_embed_model.Checked;
            Properties.Settings.Default.EmbedSky = chk_embed_sky.Checked;
            Properties.Settings.Default.AntialiasLevel = cmb_antialias.SelectedItem.ToString();
            Properties.Settings.Default.LightResolutionLevel = (int)nmr_lightres.Value;
            Properties.Settings.Default.AnistrophicLevel = (int)nmr_anisotrophy.Value;
            Properties.Settings.Default.ReplaceSkins = chk_replace_skins.Checked;
            Properties.Settings.Default.AutoRecompile = chk_recompile.Checked;

            Properties.Settings.Default.CommentColor = btn_comment_color.BackColor;
            Properties.Settings.Default.PreProcessorColor = btn_preprocessor_color.BackColor;
            Properties.Settings.Default.StringColor = btn_string_color.BackColor;
            Properties.Settings.Default.CharacterColor = btn_character_color.BackColor;
            Properties.Settings.Default.KeywordColor = btn_keyword_color.BackColor;
            Properties.Settings.Default.FunctionColor = btn_function_color.BackColor;
            Properties.Settings.Default.ComponentColor = btn_component_color.BackColor;
            Properties.Settings.Default.SemanticColor = btn_semantic_color.BackColor;
            Properties.Settings.Default.ParameterColor = btn_parameter_color.BackColor;

            Properties.Settings.Default.EditorFont = dlr_fnt.Font;

            foreach (Form frm in Classes.Variables.main_form.MdiChildren)
            {
                if (frm is Forms.frm_shader)
                {
                    ((Forms.frm_shader)frm).Editor.UpdateFont();
                    ((Forms.frm_shader)frm).Editor.UpdateColors();
                    continue;
                }

                if (frm is Forms.frm_function)
                {
                    ((Forms.frm_function)frm).UpdateFonts();
                    ((Forms.frm_function)frm).UpdateColors();
                }
            }

            Properties.Settings.Default.Save();
            this.Close();
        }

        private void SelectColor(object sender, EventArgs e)
        {
            Button btn = (Button)sender;
            dlg_clr.Color = btn.BackColor;

            if (dlg_clr.ShowDialog() != DialogResult.Cancel)
            {
                btn.BackColor = dlg_clr.Color;
            }
            
        }

        private void SelectFont(object sender, EventArgs e)
        {
            dlr_fnt.ShowDialog();
        }
    }
}
