﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace FXED.Forms
{
    public partial class frm_shader_library : Form
    {
        List<Classes.Objects.LibraryItem> items = new List<FXED.Classes.Objects.LibraryItem>();

        public frm_shader_library()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.Cancel;
        }

        private void frm_shader_library_Load(object sender, EventArgs e)
        {
            FileStream open_stream = null;
            BinaryFormatter formatter = new BinaryFormatter();
            DirectoryInfo dir = new DirectoryInfo(Application.StartupPath + "\\Library");

            foreach (FileInfo file in dir.GetFiles())
            {
                if (file.Extension == ".lcfx")
                {
                    open_stream = new FileStream(file.FullName, FileMode.Open, FileAccess.Read);
                    string type = (string)formatter.Deserialize(open_stream);
                    Classes.Objects.Effect temp_effect = (Classes.Objects.Effect)formatter.Deserialize(open_stream);

                    Classes.Objects.LibraryItem new_library_item = new FXED.Classes.Objects.LibraryItem(Path.GetFileNameWithoutExtension(file.Name),temp_effect.Author,temp_effect.Description,temp_effect.ShaderModel);
                    items.Add(new_library_item);
                    imglst_thumbs.Images.Add(temp_effect.Thumbnail);

                    ListViewItem new_item = new ListViewItem();
                    new_item.Text = new_library_item.Name;
                    new_item.Tag = file.FullName;
                    new_item.ImageIndex = imglst_thumbs.Images.Count - 1;

                    
                    if (type == "entity")
                    {
                        lst_entity.Items.Add(new_item);
                    }
                    else
                    {
                        lst_pp.Items.Add(new_item);
                    }
                    open_stream.Close();
                }
            }

        }

        string file_to_load = string.Empty;

        private void btn_ok_Click(object sender, EventArgs e)
        {
            Classes.Variables.main_form.LoadShader(file_to_load);
            this.DialogResult = DialogResult.OK;
        }

        private void lst_entity_SelectedIndexChanged(object sender, EventArgs e)
        {
            ListView listview = (ListView)sender;

            if (listview.SelectedIndices.Count == 0)
            {
                txt_author.Clear(); txt_description.Clear(); txt_model.Clear(); btn_ok.Enabled = false;
                return;
            }
            else
            {
                Classes.Objects.LibraryItem item = null;
                if (tab_library.SelectedIndex == 0)
                {
                    item = items.Find(delegate(Classes.Objects.LibraryItem lib) { return lib.Name == listview.SelectedItems[0].Text; });
                }
                else
                {
                    item = items.Find(delegate(Classes.Objects.LibraryItem lib) { return lib.Name == listview.SelectedItems[0].Text; });
                }

                txt_author.Text = item.Author;
                txt_description.Text = item.Description;
                txt_model.Text = item.ShaderModel;
                btn_ok.Enabled = true;

                file_to_load = listview.SelectedItems[0].Tag.ToString();

            }
        }

        private void tab_library_SelectedIndexChanged(object sender, EventArgs e)
        {
            txt_author.Clear(); txt_description.Clear(); txt_model.Clear(); btn_ok.Enabled = false;
            lst_entity.SelectedIndices.Clear();
            lst_pp.SelectedIndices.Clear();
        }
    }
}
