﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FXED.Forms
{
    public partial class frm_skills : Form
    {
        public frm_skills()
        {
            InitializeComponent();
            this.Location = Classes.Variables.my_effect.SkillsLocation;
            this.Size = Classes.Variables.my_effect.SkillsSize;
            this.FormClosing += new FormClosingEventHandler(frm_skills_Closing);
            this.LocationChanged += new EventHandler(FormMoved);
            this.ResizeEnd += new EventHandler(FormResized);
        }

        void frm_skills_Closing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.MdiFormClosing)
            {
                this.Hide();
                Classes.Variables.my_effect.SkillsVisible = false;
                Classes.Variables.main_form.tsitem_skills.Checked = false;
                e.Cancel = true;
            }
        }

        private void FormMoved(object sender, EventArgs e)
        {
            Classes.Variables.my_effect.SkillsLocation = this.Location;
        }

        private void FormResized(object sender, EventArgs e)
        {
            Classes.Variables.my_effect.SkillsSize = this.Size;
        }

        private void frm_skills_Load(object sender, EventArgs e)
        {
            pgr_skills.SelectedObject = Classes.Variables.my_effect.Skills;
        }

        public PropertyGrid SkillsGrid
        {
            get { return this.pgr_skills; }
            set { pgr_skills = value; }
        }

        public void SetSkillCaptions()
        {
            foreach (Classes.Objects.Skill skill in Classes.Variables.my_effect.Skills.Skills)
            {
                try
                {
                    Classes.Functions.SetDisplayName(Classes.Variables.my_effect.Skills, "Skill" + skill.SkillNumber, skill.Caption);
                }
                catch { }
            }
            this.pgr_skills.Refresh();
        }
    }
}
