﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace FXED.Forms
{
    public partial class frm_startup_options : Form
    {
        public frm_startup_options()
        {
            InitializeComponent();
            Classes.Variables.main_form.EnableMenuItems(false);
            Classes.Variables.project_changed = false;
        }

        private void CreateEntityShader(object sender, EventArgs e)
        {
            Classes.Variables.shader_type = "entity";
            Classes.Variables.my_effect.CreateDefaultEffect(Classes.Variables.shader_type);
            Classes.Variables.main_form.LoadComponents();
            this.Close();
        }

        private void CreatePPShader(object sender, EventArgs e)
        {
            Classes.Variables.shader_type = "pp";
            Classes.Variables.my_effect.CreateDefaultEffect(Classes.Variables.shader_type);
            Classes.Variables.main_form.LoadComponents();
            this.Close();
        }

        private void OpenShaderFile(object sender, EventArgs e)
        {
            if (dlg_open_effect.ShowDialog() != DialogResult.Cancel)
            {
                if (Path.GetExtension(dlg_open_effect.FileName) == ".lcfx")
                {
                    Classes.Variables.main_form.LoadShader(dlg_open_effect.FileName);
                }
                else if (Path.GetExtension(dlg_open_effect.FileName) == ".fx")
                {
                    Classes.Variables.main_form.LoadFXShader(dlg_open_effect.FileName);
                }
                this.Close();
            }
        }

        private void ShowLibrary(object sender, EventArgs e)
        {
            if (!Directory.Exists(Application.StartupPath + "\\library"))
            {
                MessageBox.Show("The directory containing the library files could not be located", "Missing directory", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            frm_shader_library library = new frm_shader_library();
            if (library.ShowDialog() == DialogResult.OK)
            {
                this.Close();
            }
        }

        private void frm_startup_options_Load(object sender, EventArgs e)
        {
            if (Directory.Exists(Application.StartupPath + "\\Library"))
            {
                DirectoryInfo dir = new DirectoryInfo(Application.StartupPath + "\\Library");
                foreach (FileInfo file in dir.GetFiles())
                {
                    if (file.Extension == ".lcfx")
                    {
                        btn_open_library.Enabled = true; return;
                    }
                }
            }
        }
    }
}
